package org.gcube.portlets.widgets.workspaceuploader.client.events;

import org.gcube.portlets.widgets.workspaceuploader.shared.WorkspaceUploaderItem;

import com.google.gwt.event.shared.GwtEvent;
import com.google.gwt.user.client.ui.HorizontalPanel;


/**
 * The Class CancelUploadEvent.
 *
 * @author Francesco Mangiacrapa francesco.mangiacrapa@isti.cnr.it
 * Sep 7, 2015
 */
public class CancelUploadEvent extends GwtEvent<CancelUploadEventHandler> {
	public static Type<CancelUploadEventHandler> TYPE = new Type<CancelUploadEventHandler>();
	private HorizontalPanel hp;
	private String fileName;
	private WorkspaceUploaderItem uploader;


	/**
	 * @return the hp
	 */
	public HorizontalPanel getHp() {
		return hp;
	}

	/**
	 * Instantiates a new cancel upload event.
	 */
	public CancelUploadEvent(WorkspaceUploaderItem uploader, HorizontalPanel hp, String fileName) {
		this.uploader = uploader;
		this.hp = hp;
		this.fileName = fileName;
	}

	/**
	 * @return the uploader
	 */
	public WorkspaceUploaderItem getUploader() {
		return uploader;
	}

	/* (non-Javadoc)
	 * @see com.google.gwt.event.shared.GwtEvent#getAssociatedType()
	 */
	@Override
	public Type<CancelUploadEventHandler> getAssociatedType() {
		return TYPE;
	}

	/* (non-Javadoc)
	 * @see com.google.gwt.event.shared.GwtEvent#dispatch(com.google.gwt.event.shared.EventHandler)
	 */
	@Override
	protected void dispatch(CancelUploadEventHandler handler) {
		handler.onCancelUpload(this);
	}

	/**
	 * @return
	 */
	public String getFileName() {
		return fileName;
	}
}
